#ifndef LPOLY_DESCR_H
#define LPOLY_DESCR_H

/* В данном файле описаны типы для создания описания функций преобразования,
   которые будут применяться с помощью lpoly_calc_val().
   Описание состоит из таблицы структур st_lpoly_interval_descr, каждая из
   которой представляет описание преобразования на одном из интервалов входного
   параметра. Таблица должна быть завершена элементом, заполненным макрасом
   LPOLY_DESCR_TABLE_END.
   Для использования таблицы должен быть экспортирован указатель на первый
   элемент таблицы, который уже можно будет передать в lpoly_calc_val().
   lpoly_calc_val() проходит по таблице и ищет первый элемент, который попадет
   в заданный интервал, после чего вызывает фукнцию calc_func из описания
   интервала, передав в нее саму st_lpoly_interval_descr.
   Если не будет найден нужный интервал, то lpoly_calc_val() верент нулевое
   значение и в качестве ok вернет 0 */


#include "lpoly.h"

/* Функция для преобразования входного значения в выходное на заданном интервале */
typedef t_lpoly_val (*t_lpoly_calc_func)(const struct st_lpoly_interval_descr *poly, t_lpoly_val val);

/* Структура описывает способ преобразования входного значения в выходное
   на заданном интервале входной переменной */
struct st_lpoly_interval_descr {
    t_lpoly_val from; /* минимальное значение входной величины, для которого действителен описываемый интервал преобразования */
    t_lpoly_val to; /* максимальное значение входной величины, для которого действителен описываемый интервал преобразования */
    t_lpoly_calc_func calc_func; /* функция для преобразования входного значения в выходное */
    const t_lpoly_val *coef; /* массив коэффициентов преобразования (значение зависит от функции) */
    unsigned coef_cnt; /* количество коэффициентво в массиве coef */
    void *ext_data; /* дополнительные данные для преобразования, если массива коэффициентов недостаточно. */
};

/* Макрос, с помощью которого должен быть проиницилизирован последний элемент
   в таблице с описанием интервалов преобразования */
#define LPOLY_DESCR_TABLE_END   {0,      0,      NULL, NULL, 0, NULL}

#endif // LPOLY_DESCR_H
